/***************************************************************************
                            -------------------
   begin                : Frag' mich was leichteres
   copyright            : (C) 2002 by Victor Rder
   email                : victor_roeder@gmx.de
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** Here resides the Import-existing-files-dialog of the Automake Manager **/
/** (a KDevelop build tool part) **/

#ifndef ADDEXISTINGFILESDLG_H
#define ADDEXISTINGFILESDLG_H

#include <tqdialog.h>
#include <tdefile.h>

#include "addexistingdlgbase.h"
#include "fileselectorwidget.h"

#include "misc.h"

class KImportIconView;
class FileSelectorWidget;
class AutoProjectWidget;
class AutoProjectPart;
class SubprojectItem;
class TargetItem;
class KFileItem;

class AddExistingFilesDialog : public AddExistingDlgBase
{
	TQ_OBJECT
  

public:
	AddExistingFilesDialog( AutoProjectPart* part, AutoProjectWidget *widget, 
	                        SubprojectItem* spitem, TargetItem* titem, TQWidget* parent = 0,
	                        const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~AddExistingFilesDialog();

private:
	FileSelectorWidget* sourceSelector;
	KImportIconView* importView;

	AutoProjectPart* m_part;
	AutoProjectWidget* m_widget;

	TargetItem* m_titem;
	SubprojectItem* m_spitem;

	KFileItemList m_importList;

protected:
	// 	virtual void resizeEvent ( TQResizeEvent* ev );
	void init();
	void importItems ();

protected slots:
	void slotAddSelected();
	void slotAddAll();
	void slotRemoveAll();
	void slotRemoveSelected();
	void slotDropped ( TQDropEvent* ev );

	void slotOk();
};

#endif // ADDEXISTINGFILESDLG_H
